class CAxis {
 public:
    double inf, sup;
    bool   logflag;
    bool   force;

    CAxis( bool _log ) :
        logflag(_log), force(false) { setAuto(); };

    void setLog( bool _log );

    void setAuto();
    void setLimits( string axnam, double _inf, double _sup );
    void setRoundedLimits( string axnam, double _inf, double _sup );
    void ask_and_set( const string& quest );

    string str() const;
    string info() const;
    bool finite() const;
    bool contains( double val ) const;
    bool close_enough( double v1, double v2, double tol ) const;
    double value2plotcoord( double v ) const;
    double value2ploterror( double v, double dv ) const;
    void set_xgrid( vector<double>& x, int n ) const;
    double pc( double v ) const;
    double pcerr( double v, double dv ) const;
    double inf_pos() const;
    void calc_ticks( int *ntack, double **tack, int *ntpt, double *ticklim )
        const;
};
